
// =========================================================
// Main class for objects in the gasme which do not move
// =========================================================
class staticThing{
    constructor(x,y,context){
        this.x = x;
        this.y = y;
        this.colour = "#CCCCCC";
        this.width = 30;
        this.height = 30;
        this.context = context;
        this.alive = true;

    }

    draw()
    {
        this.context.fillStyle = this.colour;
        this.context.fillRect(this.left(),this.top(),this.width,this.height);
    }


    toBeCulled()
    {
        return !this.alive;
    }

    kill()
    {
        this.alive = false;
    }



    left() { return this.x - this.width/2;}
    right() { return this.x + this.width/2;}
    top() { return this.y - this.height/2;}
    bottom() { return this.y + this.width/2;}


    detectCollison(anotherExistingThing)
    {
        if (this.right() < anotherExistingThing.left()) return false;
        if (this.left() > anotherExistingThing.right()) return false;
        if (this.top() > anotherExistingThing.bottom()) return false;
        if (this.bottom() < anotherExistingThing.top()) return false;
        return true;
    }

    atLeftEdge() { if (this.left() <= 0) return true; return false; }
    atRightEdge() { if (this.right() >= this.context.canvas.width) return true; return false; }
    atTopEdge() { if (this.top() <= 0) return true; return false; }
    atBottomEdge() { if (this.bottom() >= this.context.canvas.height)  return true; return false; }

    bouceOffEdges()
    {
        if (this.atLeftEdge() || (this.atRightEdge()))
        {
            this.xSpeed *= -1;
        }
        if (this.atTopEdge() || (this.atBottomEdge()))
        {
            this.ySpeed *= -1;
        }
    }

    constrainToEdges()
    {
        if (this.atLeftEdge())
        {
            this.x = this.width/2
            this.xSpeed = 0;
        }

        if (this.atRightEdge())
        {
            this.x = this.context.canvas.width - this.width/2
            this.xSpeed = 0;
        }

        if (this.atTopEdge())
        {
            this.y = this.height/2;
            this.ySpeed = 0;
        }

        if (this.atBottomEdge())
        {
            this.y = this.context.canvas.height - this.height/2
            this.ySpeed = 0;
        }

    }

    collidesWithAnyOf(thingList)
    {
        for(var i=0; i<thingList.length; i++){
            if(this.detectCollison(thingList[i])) return thingList[i];
        }
        return null;
    }

}

class movingThing extends staticThing{
    constructor(x,y,context,xSpeed,ySpeed)
    {
        super(x,y,context);
        this.xSpeed = xSpeed;
        this.ySpeed = ySpeed;
    }

    move(listOfObstacles)
    {
        this.x += this.xSpeed;
        if (this.collidesWithAnyOf(listOfObstacles) != null)
        {
            this.x -= this.xSpeed;
            this.xSpeed *= -1;
        } 

        this.y += this.ySpeed;
        if (this.collidesWithAnyOf(listOfObstacles) != null) {
            this.y -= this.ySpeed;
            this.ySpeed *= -1;
        }

        this.bouceOffEdges();
    }
}

class controllableMovingThing extends movingThing{
    constructor(x,y,context,xSpeed,ySpeed,keyList)
    {
        super(x,y,context,xSpeed,ySpeed);
        this.upKey = keyList[0];
        this.leftKey = keyList[1];
        this.downKey = keyList[2];
        this.rightKey = keyList[3];

    }
    reactToKeypress(key)
    {
        if(key == this.upKey) this.ySpeed = -3;
        if(key == this.downKey) this.ySpeed = 3;
        if(key == this.leftKey) this.xSpeed = -3;
        if(key == this.rightKey) this.xSpeed = 3;

    }
}

